#include "Peak2.h"

BLOCKSIZE       =1024
BLOCKBUFFER     =VIDEO_MEM
BLOCKBUFFERTOP  =$FFFF

VARADD          =TEXT_MEM
VARSIZE         =TEXT_MEM+2

RelocationArea  =HIGH_STACK
ReloHeader      =HIGH_STACK+2
VarAddress      =HIGH_STACK+4
VarAddress2     =HIGH_STACK+6
VarLength       =HIGH_STACK+8
BlockLength     =HIGH_STACK+10
DEST            =HIGH_STACK+12
MoveSize        =HIGH_STACK+14

.org $8BF9                      ;This must be patched in at 8BF9, or it won't
                                ;work.  The simplest way is just to store
                                ;this into the current shell on the home
                                ;screen.
Header:
.dw     $5300
.db     0

CustomData:
.db     $04

MenuJump:
        jp Start

MenuText:
.db     "Peak",0,0

Routines1:                      ;8C05
        jp Execute

ZShell40:			;8C09 needed for ZShell 4.0 compatibility
	jp ROM_CALLER		;ROM_CALL(index)
	jp NZ,Return		;CALL_Z(addr)
	jp CALLER		;CALL_(addr)
	jp Z,Return		;CALL_NZ(addr)
	jp CALLER
	jp NC,Return		;CALL_C(addr)
	jp CALLER
	jp C,Return		;CALL_NC(addr)
	jp CALLER
	jp NZ,Return		;JUMP_Z(addr)
	jp JUMPER		;JUMP_(addr)
	jp Z,Return		;JUMP_NZ(addr)
	jp JUMPER
	jp NC,Return		;JUMP_C(addr)
	jp JUMPER
	jp C,Return		;JUMP_NC(addr)
	jp JUMPER

Program_Address:	;8C3C
.dw     $0000		;PROGRAM_ADDR

RomVersionByte:		;8C3E
.db     $00		;ROM_VERS

ZShellVersion:		;8C3F
.db     $40		;$40 for ZShell 4.0 compatibility (ZSHELL_VER)

ZShellBits:		;8C40	(ZS_BITS)
.db     $00             ;warpout ability (for menus)

RomTable:
        jp $FFFF
        jp $FFFF
        jp $FFFF
        jp $FFFF
        jp $FFFF
        jp $FFFF
        jp $FFFF
        jp $FFFF
        jp $FFFF
        jp $FFFF
        jp $FFFF
        jp $FFFF
        jp $FFFF
        jp $FFFF
        jp $FFFF

ROM_CALLER:			;196/191 clock cycles, without hldata
	ld (HLDATA+1),HL	;save for later

	pop HL			;get pointer for ret
	inc HL			;point it past the data byte of ROM_CALL()
	push HL			;put it back
	dec HL

	push AF			;save flags for later
	push DE
	ld E,(HL)		;get ROM_CALL number in E
	bit 7,E			;test if its FIND_PIXEL
	jr Z,NotFP		;if not, jr to NotFP
	ld E,$0E		;if so, make it $0E (FIND_PIXEL's actual
				;offset in memory)

NotFP:
	ld HL,ROM_TABLE		;HL -> ROM table
	ld A,E
	add A,A
	add A,E			;A=E*3
	ld E,A			;DE=offset of ROM call
	ld D,0
	add HL,DE		;HL -> address word for ROM call in table

	ld (CHANGER_JUMP+1),HL	;fix jp at end of routine to point to ROM
				;jump table

FixUp:
	pop DE
	pop AF			;it is here, instead of before, to ensure
				;that the flags are the same as before

HLDATA:				;20 clock cycles including changer jump
	ld HL,$FFFF		;the FF's will be overwritten EVERY time

CHANGER_JUMP:
	jp $FFFF		;the FF's will be overwritten EVERY time
 
CALLER:
	ld (HLDATA+1),HL	;save for later
	pop HL			;get pointer for ret
	inc HL			;point it past the data word of call
	inc HL
	push HL			;put it back
	dec HL
	dec HL

Common2Jump:
	push AF
	push DE
	
	ld E,(HL)		;get offset of call
	inc HL
	ld D,(HL)

	ld HL,(PROGRAM_ADDR)
	add HL,DE		;get actual address of subroutine

	ld (CHANGER_JUMP+1),HL	;change the jump pointer
	jr FixUp

JUMPER:
	ld (HLDATA+1),HL	;save for later
	pop HL			;get pointer for ret

	jr Common2Jump

Return:				
	ex (SP),HL
	inc HL
	inc HL
	ex (SP),HL
	ret

ReloProg:
        ld HL,(VarAddress)
        ld (VarAddress2),HL

        ld DE,(RelocationArea)
        ld (DEST),DE

        ld C,(HL)
        inc HL
        ld B,(HL)
        inc HL

        push HL                 ;header check
        push DE
        call LD_HL_MHL
        ld DE,(ReloHeader)
        call CP_HL_DE
        pop DE
        pop HL
        ret NZ

        push BC
        push HL
        push DE
        call AVATFix
        pop DE
        pop HL

LoopBack:
        ld (VarLength),BC
        ld (BlockLength),BC

        push HL
        push DE

        ld H,B
        ld L,C

        ld DE,BLOCKSIZE

        ex DE,HL

        call CP_HL_DE
        jr NC,UnderSize

        ld BC,BLOCKSIZE
        ld (VarLength),BC

UnderSize:
        pop DE
        pop HL

        ld DE,BLOCKBUFFER
        ld BC,(VarLength)
        ldir

        dec HL
        ex DE,HL

        push DE
        ld HL,(VarAddress)
        inc HL

        push HL
        ld DE,(DEST)

        or A
        sbc HL,DE

        ld B,H
        ld C,L
        pop HL
        pop DE

        inc BC
        ld (MoveSize),BC
        lddr

        ld HL,BLOCKBUFFER
        ld DE,(DEST)
        ld BC,(VarLength)
        ldir

TestBlockSize:
        ld HL,BLOCKSIZE
        ld DE,(BlockLength)
        call CP_HL_DE
        jr NC,UnderSize2

        ld DE,BLOCKSIZE
        ld HL,(BlockLength)
        or A
        sbc HL,DE
        push HL
        ex DE,HL

        ld BC,BLOCKSIZE

        ld HL,(DEST)
        add HL,BC
        ld (DEST),HL

        ld HL,(VarAddress)
        add HL,BC
        ld (VarAddress),HL

        pop BC
        ld (HL),C
        inc HL
        ld (HL),B
        inc HL

        jr LoopBack

UnderSize2:
        ld HL,(VarAddress)
        ld DE,(BlockLength)
        add HL,DE
        ld (VarAddress),HL

        xor A

        ld (HL),A
        inc HL
        ld (HL),A

        ld HL,($8BF7)
        add HL,BC
        ld ($8BF7),HL

RExecute:
        ld HL,(RelocationArea)
        inc HL
        inc HL
        ld E,(HL)
        ld D,0
        add HL,DE
        inc HL
        ld (FixReloCall+1),HL

        ld HL,(VarAddress2)
        push HL
        ld HL,(RelocationArea)
        push HL
        ld HL,(MoveSize)
        push HL

FixReloCall:
        call $FFFF

        pop HL
        ld (MoveSize),HL
        pop HL
        ld (RelocationArea),HL
        pop HL
        ld (VarAddress2),HL

        pop BC
        ld (BlockLength),BC

        ld HL,(VarAddress2)
        add HL,BC

        ld (HL),C
        inc HL
        ld (HL),B
        ld (VarAddress),HL
        ld (VARADD),HL
        ld (VARSIZE),BC

Delocate:
        ld HL,BLOCKSIZE
        ld DE,(BlockLength)
        ld (VarLength),DE
        call CP_HL_DE
        jr NC,UnderSize3

        ld (VarLength),HL

UnderSize3:
        ld HL,(RelocationArea)
        dec HL
        ld DE,(BlockLength)
        add HL,DE
        ld DE,BLOCKBUFFERTOP
        ld BC,(VarLength)
        lddr                    ;Copy out

        ex DE,HL

        push DE
        ld HL,(RelocationArea)
        ld DE,(BlockLength)
        add HL,DE
        pop DE
        inc DE
        ld BC,(MoveSize)
        ldir                    ;Move it all down

        ld HL,BLOCKBUFFERTOP
        ld DE,(VarAddress)
        ld BC,(VarLength)
        lddr
        ld (VarAddress),DE     ;copy it back in

        ld HL,(BlockLength)
        ld DE,(VarLength)
        or A
        sbc HL,DE
        jr Z,Done
        ld (BlockLength),HL     ;Set new length

        jr Delocate

Done:
        ld BC,(VARSIZE)

        jp SVATFix

HelloMarker:            ;8E0F
.db     "HELLO"

Routines2:
        jp PatchROM     ;8DFE
        jp F_B_Bytes    ;8E17
        jp CheckVAT     ;8E1A

VATName:                ;8E1D
.db     0,0,0,0,0,0,0,0,0

AutoRun:
.db     7,"AutoRun",0           ;Extra byte at end so you can change it

F_B_Bytes:			;(F_B_BYTES) fill B bytes at HL with A
	ld (HL),A
	inc HL
	djnz F_B_Bytes
	ret

SetDefaults:			;sets all the defaults
	xor A			;A=0
	ld ($834B),A		;set printing parameters
	ld ($8353),A

	ld HL,$0000		;set printing parameters
	ld ($800C),HL		;Cursor position
	ld ($8334),HL		;Menu cursor position

	APD_OFF			;turn off APD
	ret

CheckVAT:
        ld (Compare1+1),A

CheckVAT1:
        ld DE,(VAT_END)

        call CP_HL_DE

        jr Z,None

Compare1:
        ld A,$FF
        cp (HL)
        jr Z,FoundOne             ;fix

        dec HL
        dec HL
        dec HL

        ld E,(HL)
        ld D,0

        scf
        ccf

        sbc HL,DE
        dec HL
        jr CheckVAT1

None:
        scf
        ret

FoundOne:
        dec HL
        ld E,(HL)
        dec HL
        ld D,(HL)
        dec HL

        push DE
        ld B,(HL)
        ld DE,VC_NAME
        ld A,B
        ld (DE),A

VATCopy:
        dec HL
        inc DE

        ld A,(HL)
        ld (DE),A

        djnz VATCopy

        dec HL
        pop DE

        scf
        ccf
        ret


;input: DE-> destination address
;       HL-> patch data
;Return:DE-> byte after last patch
;       HL-> byte after last piece of patched data
;       A='I' if incompatible ROM version
;       A='P' if successful patch
PatchROM:
        push DE                 ;save destination address

        ld A,(ROM_VERS)         ;MUST be ZShell 4.0 compatible shell
	ld C,A

	ld E,0

CheckROM:
        cp $35
	jr Z,Found

	inc E
	cp $91
	jr Z,Found

	inc E
	cp $97
	jr Z,Found

	inc E
	cp $3D
	jr Z,Found

	cp $8E
	jr Z,Found

        cp $5E
        jr Z,Found

	inc E
	cp $57
	jr Z,Found

Error3:			;error if no correct ROM version
        ld A,'I'
        ret

Found:
	ld B,(HL)
	inc HL

	push BC

        xor A

        sla E

MulEB:
	add A,E
	djnz MulEB

Silly:
	ld C,A

	ld B,0

	add HL,BC

	pop BC

        pop DE

LoadPatches:
	ld A,$C3
	ld (DE),A
	inc DE			;load jump byte

	ld A,(HL)
	ld (DE),A
	inc HL
	inc DE			;low byte

	ld A,(HL)
	ld (DE),A
	inc HL
	inc DE			;high byte

	djnz LoadPatches

        ld A,'P'
        ret

ROM_DATA:
.db     15

Rom10:
.dw     $3FE0   ;TX_CHARPUT
.dw     $3B78   ;D_LT_STR
.dw     $3BB4   ;M_CHARPUT
.dw     $3BBA   ;D_ZM_STR
.dw     $3BFC   ;D_LM_STR
.dw     $3C92   ;GET_T_CUR
.dw     $3D82   ;SCROLL_UP
.dw     $3DE8   ;TR_CHARPUT
.dw     $3DEE   ;CLEARLCD
.dw     $3DF4   ;D_HL_DECI
.dw     $3E54   ;CLEARTEXT
.dw     $3E60   ;D_ZT_STR
.dw     $3E96   ;BUSY_OFF
.dw     $3EAE   ;BUSY_ON
.dw     $6B6D   ;FIND_PIXEL

Rom9:
.dw     $3FC5   ;TX_CHARPUT
.dw     $3B5D   ;D_LT_STR
.dw     $3B99   ;M_CHARPUT
.dw     $3B9F   ;D_ZM_STR
.dw     $3BE1   ;D_LM_STR
.dw     $3C77   ;GET_T_CUR
.dw     $3D67   ;SCROLL_UP
.dw     $3DCD   ;TR_CHARPUT
.dw     $3DD3   ;CLEARLCD
.dw     $3DD9   ;D_HL_DECI
.dw     $3E39   ;CLEARTEXT
.dw     $3E45   ;D_ZT_STR
.dw     $3E7B   ;BUSY_OFF
.dw     $3E93   ;BUSY_ON
.dw     $6B6D   ;FIND_PIXEL

Rom8:
.dw     $3FF5   ;TX_CHARPUT
.dw     $3BA5   ;D_LT_STR
.dw     $3BE1   ;M_CHARPUT
.dw     $3BE7   ;D_ZM_STR
.dw     $3C29   ;D_LM_STR
.dw     $3CA7   ;GET_T_CUR
.dw     $3D97   ;SCROLL_UP
.dw     $3DFD   ;TR_CHARPUT
.dw     $3E03   ;CLEARLCD
.dw     $3E09   ;D_HL_DECI
.dw     $3E63   ;CLEARTEXT
.dw     $3E6F   ;D_ZT_STR
.dw     $3EAB   ;BUSY_OFF
.dw     $3EC3   ;BUSY_ON
.dw     $6C9A   ;FIND_PIXEL

Rom456:
.dw     $3FF1   ;TX_CHARPUT
.dw     $3BA1   ;D_LT_STR
.dw     $3BDD   ;M_CHARPUT
.dw     $3BE3   ;D_ZM_STR
.dw     $3C25   ;D_LM_STR
.dw     $3CA3   ;GET_T_CUR
.dw     $3D93   ;SCROLL_UP
.dw     $3DF9   ;TR_CHARPUT
.dw     $3DFF   ;CLEARLCD
.dw     $3E05   ;D_HL_DECI
.dw     $3E5F   ;CLEARTEXT
.dw     $3E6B   ;D_ZT_STR
.dw     $3EA7   ;BUSY_OFF
.dw     $3EBF   ;BUSY_ON
.dw     $6C9A   ;FIND_PIXEL

Rom3A:
.dw     $3FEE   ;TX_CHARPUT
.dw     $3B9E   ;D_LT_STR
.dw     $3BDA   ;M_CHARPUT
.dw     $3BE0   ;D_ZM_STR
.dw     $3C22   ;D_LM_STR
.dw     $3CA0   ;GET_T_CUR
.dw     $3D90   ;SCROLL_UP
.dw     $3DF6   ;TR_CHARPUT
.dw     $3DFC   ;CLEARLCD
.dw     $3E02   ;D_HL_DECI
.dw     $3E5C   ;CLEARTEXT
.dw     $3E68   ;D_ZT_STR
.dw     $3EA4   ;BUSY_OFF
.dw     $3EBC   ;BUSY_ON
.dw     $6C9A   ;FIND_PIXEL

AVATFix:        ;50 bytes       ;input: BC = amount to add to all affected
                                ;       VAT Entries
	ld HL,$FA6C

FixVATLoop:
	ld E,(HL)		;name size byte
	dec HL

	ld D,0

	sbc HL,DE		;HL points to type byte for next var

	ld DE,(VAT_END)
	call CP_HL_DE
        ret Z                   ;exit when VAT is fixed

	dec HL
	ld E,(HL)
	dec HL
	ld D,(HL)		;DE holds address of var
	push HL
        ld HL,(VarAddress2)     ;compare to original address of shrunk var

	ex DE,HL

	push HL
	sbc HL,DE
	pop HL

	ex DE,HL
	pop HL

	jr Z,False
	jp P,True

False:
	ex DE,HL
	add HL,BC
	ex DE,HL		;add DE,BC

True:
	ld (HL),D
	inc HL
	ld (HL),E		;put it back
	dec HL
	dec HL

	jr FixVATLoop

SVATFix:                        ;input: BC = amount to sub from all affected
                                ;       VAT Entries
	ld HL,$FA6C

SFixVATLoop:
	ld E,(HL)		;name size byte
	dec HL

	ld D,0

	sbc HL,DE		;HL points to type byte for next var

	ld DE,(VAT_END)
	call CP_HL_DE
        ret Z                   ;exit when VAT is fixed

	dec HL
	ld E,(HL)
	dec HL
	ld D,(HL)		;DE holds address of var
	push HL
        ld HL,(VARADD)          ;compare to original address of shrunk var
        dec HL

	ex DE,HL

	push HL
	sbc HL,DE
	pop HL

	ex DE,HL
	pop HL

        jr Z,SFalse
        jp P,STrue

SFalse:
	ex DE,HL
        or A
        sbc HL,BC
        ex DE,HL                ;sub DE,BC

STrue:
	ld (HL),D
	inc HL
	ld (HL),E		;put it back
	dec HL
	dec HL

        jr SFixVATLoop

Start:
	ld HL,($800C)		;normal cursor position
	push HL
	
	call SetDefaults

        ld A,7
        out (5),A
        ld A,($7FFF)
        ld (ROM_VERS),A

        ld DE,ROM_TABLE
        ld HL,ROM_DATA
        call PatchROM
        cp 'P'
        jr NZ,ExitBreak

RunMenu:
        ld HL,AutoRun-1
        LD_OP1_HL
        call Execute

ExitFromShell:
	set 1,(IY+13)
	ROM_CALL(CLEARTEXT)	;fill TEXT_MEM with spaces so we don't fill
				;the screen with garbage on exit

ExitBreak:
	call SetDefaults	;return with correct printing parameters

        PSCROLL

	pop HL
	ld ($800C),HL		;restore cursor

	jp HOME_SCREEN		;jump to home screen (displays contents of
				;text memory as ascii)

Execute:
        call ZShellProg
        ROM_CALL(BUSY_OFF)      ;turn off busy indicator

        ld DE,$5002
        ld (ReloHeader),DE

        ld DE,RelocationSpot
        ld (RelocationArea),DE
        call ReloProg

        ld DE,$5000
        ld (ReloHeader),DE

        ld DE,$8E57-3
        ld (RelocationArea),DE
        jp ReloProg

ZShellProg:
        SEARCH_VAT
	ret C

        ex DE,HL                ;exchange, so we can use (HL)
        ld (VarAddress),HL

        inc HL                  ;point it at the ZShell header, so we can
        inc HL                  ;check it

        push HL
        call LD_HL_MHL
        ld DE,$FD00             ;ZShell Program
        call CP_HL_DE
        jr Z,SkipCheck2

        ld DE,$7002             ;Peak Non-Relocation Prog
        call CP_HL_DE

SkipCheck2:
        pop HL
        ret NZ

        inc HL
        inc HL

;        xor A                   ;A=0
;        cp (HL)                 ;header part 1
;        ret NZ                  ;kick out if not a ZShell 4.0 file
;        inc HL
;        ld A,$FD
;        cp (HL)                 ;header part 2
;        ret NZ                  ;kick out if not a ZShell 4.0 file
;        inc HL                  ;point past header to name length byte

	inc HL			;HL -> description data of file

ExeAtHL:
	ld DE,(PROGRAM_ADDR)	;can be run recursively (A program runs
	push DE			;another program)

	ld (PROGRAM_ADDR),HL	;set PROGRAM_ADDR, so programs will work

Execution:
	xor A			;looking for the zero at end of description
	ld BC,90		;90 bytes is longer than any description I've
	cpir			;ever seen
	ld (CallMan+1),HL	;execute from the byte after description

	ld HL,TEXT_MEM		;zero the text memory, like in ZShell
	ld B,168		;length of the text mem

	call F_B_Bytes
	call SetDefaults

	ROM_CALL(BUSY_OFF)	;turn off busy indicator

CallMan:
	call $FFFF		;will return to caller after program runs
	pop HL
	ld (PROGRAM_ADDR),HL
	ret


RelocationSpot:
.end


